From f6a511bf7af19fca44e7fa80872664e8a9412a1e Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Oct 13 2017 17:26:09 +0000
Subject: [PATCH 986/1001] Allow using other tags than input in the widget config


---

diff --git a/hubs/static/client/app/components/SimpleWidgetConfig.js b/hubs/static/client/app/components/SimpleWidgetConfig.js
index ca817dd..8228438 100644
--- a/hubs/static/client/app/components/SimpleWidgetConfig.js
+++ b/hubs/static/client/app/components/SimpleWidgetConfig.js
@@ -14,9 +14,11 @@ export default class SimpleWidgetConfig extends React.Component {
       return (
         <fieldset className="form-group row" key={field.name}>
           <strong>{field.label}</strong>
-          <input
+          <field.renderTag
             className="form-control"
-            type="text"
+            type={
+              field.renderTag === "input" ? field.renderType : null
+            }
             value={this.props.values[field.name] || ""}
             name={field.name}
             onChange={(e) => {
diff --git a/hubs/tests/test_widget_base.py b/hubs/tests/test_widget_base.py
index cb834d1..d416897 100644
--- a/hubs/tests/test_widget_base.py
+++ b/hubs/tests/test_widget_base.py
@@ -159,7 +159,10 @@ class WidgetTest(APPTest):
                 {'default': 'I am a Fedora user, and this is my about',
                  'help': 'Text about a user.',
                  'label': 'Text',
-                 'name': 'text'},
+                 'name': 'text',
+                 'renderTag': 'input',
+                 'renderType': 'text',
+                 },
             ],
             'position': 'right',
             'selfUrl': '/api/hubs/ralph/widgets/{}/'.format(widget.idx),
diff --git a/hubs/tests/widgets/test_halp.py b/hubs/tests/widgets/test_halp.py
index 715fa78..673ae66 100644
--- a/hubs/tests/widgets/test_halp.py
+++ b/hubs/tests/widgets/test_halp.py
@@ -128,11 +128,15 @@ class HalpViewsTestCase(WidgetTest):
                  'help': 'A comma-separated list of hubs to monitor.',
                  'label': 'Hubs',
                  'name': 'hubs',
+                 'renderTag': 'input',
+                 'renderType': 'text',
                  },
                 {'default': 4,
                  'help': 'The number of requests per page to display.',
                  'label': 'Requests per page',
                  'name': 'per_page',
+                 'renderTag': 'input',
+                 'renderType': 'text',
                  },
             ],
             'position': 'right',
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index db63192..bd10afc 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -9,50 +9,12 @@ import six
 from importlib import import_module
 from .caching import CachedFunction
 from .view import WidgetView
+from .parameters import WidgetParameter
 
 
 log = logging.getLogger(__name__)
 
 
-class WidgetParameter(object):
-    """
-    Configuration option for a widget.
-
-    A widget can be configured differently for each instance of this widget in
-    a hub.  The list of configuration options is described by the list of
-    :py:class:`WidgetParameter` objects returned by the widget's
-    :py:meth:`~Widget.get_parameters` method.
-
-    The value of the parameter is stored in the database as the value returned
-    by the validator's call.  It can thus be a string, an integer, a list, a
-    dict, or any JSON-serializable value.
-
-    Attributes:
-        name (str): The name of the parameter.
-        label (str): A humanized name of the parameter, which will be shown in
-            the UI.
-        default: The default value if this parameter is not set.
-        validator (callable): A validator function that will be used to convert
-            the parameter value to a JSON-serializable value, raising an
-            exception if it is invalid.
-        help (str): A help text that will be shown in the UI.
-        secret (bool): If True, this parameter will not be exposed to users
-            viewing the widget, it will only be available in the widget
-            configuration.
-    """
-
-    _attrs = ('name', 'label', 'default', 'validator', 'help', 'secret')
-
-    def __init__(self, **kwargs):
-        for name in self._attrs:
-            setattr(self, name, kwargs.pop(name, None))
-        for name in kwargs:
-            raise TypeError("Invalid attribute: %s" % name)
-        # Set default validator
-        if self.validator is None:
-            self.validator = lambda x: x
-
-
 class Widget(object):
     """
     The main widget class, you must subclass it to create a widget.
@@ -254,16 +216,10 @@ class Widget(object):
             hiddenIfEmpty=self.hidden_if_empty,
             cssClass=self.display_css,
             isReact=self.is_react,
-            params=[],
+            params=[
+                param.to_dict() for param in self.get_parameters()
+            ],
         )
-        for param in self.get_parameters():
-            param_data = dict(
-                name=param.name,
-                label=param.label,
-                default=param.default,
-                help=param.help,
-                )
-            props["params"].append(param_data)
         if instance is not None:
             props.update({
                 "idx": instance.idx,
diff --git a/hubs/widgets/parameters.py b/hubs/widgets/parameters.py
new file mode 100644
index 0000000..43c672e
--- /dev/null
+++ b/hubs/widgets/parameters.py
@@ -0,0 +1,65 @@
+from __future__ import unicode_literals, absolute_import
+
+from .validators import Noop
+
+
+class WidgetParameter(object):
+    """
+    Configuration option for a widget.
+
+    A widget can be configured differently for each instance of this widget in
+    a hub.  The list of configuration options is described by the list of
+    :py:class:`WidgetParameter` objects returned by the widget's
+    :py:meth:`~Widget.get_parameters` method.
+
+    The value of the parameter is stored in the database as the value returned
+    by the validator's call.  It can thus be a string, an integer, a list, a
+    dict, or any JSON-serializable value.
+
+    Attributes:
+        name (str): The name of the parameter.
+        label (str): A humanized name of the parameter, which will be shown in
+            the UI.
+        default: The default value if this parameter is not set.
+        validator (callable): A validator function that will be used to convert
+            the parameter value to a JSON-serializable value, raising an
+            exception if it is invalid.
+        help (str): A help text that will be shown in the UI.
+        secret (bool): If True, this parameter will not be exposed to users
+            viewing the widget, it will only be available in the widget
+            configuration.
+        render_tag (str): The HTML tag to use when rendering.
+        render_type (str): The HTML type attribute to use when rendering if the
+            tag is ``input``.
+    """
+
+    _defaults = {
+        "label": None,
+        "default": None,
+        "help": None,
+        "validator": Noop,
+        "secret": False,
+        "render_tag": "input",
+        "render_type": "text",
+    }
+
+    def __init__(self, name, **kwargs):
+        self.name = name
+        for attr, default in self._defaults.items():
+            setattr(self, attr, kwargs.pop(attr, default))
+        for kw in kwargs:
+            raise TypeError("Invalid argument: %s" % kw)
+
+    def to_dict(self):
+        """
+        Returns:
+            (dict): A JS-ready representation of the parameter.
+        """
+        return dict(
+            name=self.name,
+            label=self.label,
+            default=self.default,
+            renderTag=self.render_tag,
+            renderType=self.render_type,
+            help=self.help,
+            )
diff --git a/hubs/widgets/validators.py b/hubs/widgets/validators.py
index f8c5b8f..85424fb 100644
--- a/hubs/widgets/validators.py
+++ b/hubs/widgets/validators.py
@@ -18,6 +18,11 @@ import requests
 import six
 
 
+def Noop(value):
+    """Does no validation, just return the value."""
+    return value
+
+
 def Required(value):
     """Raises an error if the value is ``False``-like."""
     if not bool(value):

